<?php
require_once('localfunctions.php');

class block_my_courses_and_categories extends block_base {
    public function init() {
        $this->title = get_string('my_courses_and_categories', 'block_my_courses_and_categories');
    }

    public function get_content() {
        global $CFG, $OUTPUT;

        if ($this->content !== null) {
            return $this->content;
        }

        $this->content = new stdClass();
        $courses = block_my_courses_and_categories_get_courses();
        if(empty($courses)) {
            $this->content->text = '';
            return $this->content;
        }

        $output = $this->page->get_renderer('block_my_courses_and_categories');
        $courseslist = new \block_my_courses_and_categories\output\course_lists($courses);

        $html = $output->render($courseslist);
        $html .= attach_js(5);
        $this->content->text = $html;

        return $this->content;
    }

    public function hide_header() {
        return true;
    }

    public function get_aria_role() {
        return 'navigation';
    }
}
