<?php
namespace block_my_courses_and_categories\output;
defined('MOODLE_INTERNAL') || die();

use moodle_url;
use renderable;
use renderer_base;
use templatable;

class course_lists implements renderable, templatable {

    protected $studyingtitle;
    protected $teachingtitle;
    protected $categoriestitle;
    protected $studyingcourses;
    protected $teachingcourses;
    protected $coursecategories;
    protected $studyingshowmore;
    protected $teachingshowmore;
    protected $categoriesshowmore;

    public function __construct($courses) {
        $this->studyingcourses = isset($courses['studying']) ? $courses['studying'] : array();
        $this->teachingcourses = isset($courses['teaching']) ? $courses['teaching'] : array();
        $this->coursecategories = isset($courses['categories']) ? $courses['categories'] : array();
        $this->studyingtitle = get_string('studying', 'block_my_courses_and_categories');
        $this->teachingtitle = get_string('teaching', 'block_my_courses_and_categories');
        $this->categoriestitle = get_string('categories', 'block_my_courses_and_categories');
        $this->studyingshowmore = isset($courses['showmores']['studying']) ? $courses['showmores']['studying'] : array();
        $this->teachingshowmore = isset($courses['showmores']['teaching']) ? $courses['showmores']['teaching'] : array();
        $this->categoriesshowmore = isset($courses['showmores']['categories']) ? $courses['showmores']['categories'] : array();
    }

    public function export_for_template(renderer_base $output) {
        $data = [
            'studyingtitle' =>   $this->studyingtitle,
            'teachingtitle' =>   $this->teachingtitle,
            'categoriestitle' => $this->categoriestitle,
            'studyinglist' =>    $this->studyingcourses,
            'teachinglist' =>    $this->teachingcourses,
            'categorieslist' =>  $this->coursecategories,
            'studyingshowmore' => $this->studyingshowmore,
            'teachingshowmore' => $this->teachingshowmore,
            'categoriesshowmore' => $this->categoriesshowmore
        ];

        return $data;
    }
}
